Index: branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/Properties/Settings.Designer.cs
===================================================================
--- branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/Properties/Settings.Designer.cs	(revision 216)
+++ branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/Properties/Settings.Designer.cs	(revision 217)
@@ -1,24 +1,3 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-//------------------------------------------------------------------------------
+﻿//------------------------------------------------------------------------------
 // <auto-generated>
 //     This code was generated by a tool.
@@ -42,18 +21,4 @@
             get {
                 return defaultInstance;
-            }
-        }
-        
-        [global::System.Configuration.UserScopedSettingAttribute()]
-        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("<?xml version=\"1.0\" encoding=\"utf-16\"?>\r\n<ArrayOfString xmlns:xsi=\"http://www.w3." +
-            "org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\r\n  <s" +
-            "tring>http://update.heuristiclab.com/hl-nextgen/</string>\r\n</ArrayOfString>")]
-        public global::System.Collections.Specialized.StringCollection PluginSources {
-            get {
-                return ((global::System.Collections.Specialized.StringCollection)(this["PluginSources"]));
-            }
-            set {
-                this["PluginSources"] = value;
             }
         }
@@ -106,4 +71,18 @@
             }
         }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("<?xml version=\"1.0\" encoding=\"utf-16\"?>\r\n<ArrayOfString xmlns:xsi=\"http://www.w3." +
+            "org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\r\n  <s" +
+            "tring>http://update.heuristiclab.com/hl30/</string>\r\n</ArrayOfString>")]
+        public global::System.Collections.Specialized.StringCollection PluginSources {
+            get {
+                return ((global::System.Collections.Specialized.StringCollection)(this["PluginSources"]));
+            }
+            set {
+                this["PluginSources"] = value;
+            }
+        }
     }
 }
Index: branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/Properties/Settings.settings
===================================================================
--- branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/Properties/Settings.settings	(revision 216)
+++ branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/Properties/Settings.settings	(revision 217)
@@ -3,10 +3,4 @@
   <Profiles />
   <Settings>
-    <Setting Name="PluginSources" Type="System.Collections.Specialized.StringCollection" Scope="User">
-      <Value Profile="(Default)">&lt;?xml version="1.0" encoding="utf-16"?&gt;
-&lt;ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"&gt;
-  &lt;string&gt;http://update.heuristiclab.com/hl-nextgen/&lt;/string&gt;
-&lt;/ArrayOfString&gt;</Value>
-    </Setting>
     <Setting Name="CacheDir" Type="System.String" Scope="User">
       <Value Profile="(Default)">plugins\cache</Value>
@@ -21,4 +15,10 @@
       <Value Profile="(Default)">plugins\temp</Value>
     </Setting>
+    <Setting Name="PluginSources" Type="System.Collections.Specialized.StringCollection" Scope="User">
+      <Value Profile="(Default)">&lt;?xml version="1.0" encoding="utf-16"?&gt;
+&lt;ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"&gt;
+  &lt;string&gt;http://update.heuristiclab.com/hl30/&lt;/string&gt;
+&lt;/ArrayOfString&gt;</Value>
+    </Setting>
   </Settings>
 </SettingsFile>
Index: branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/app.config
===================================================================
--- branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/app.config	(revision 216)
+++ branches/3.0/sources/HeuristicLab.PluginInfrastructure.GUI/app.config	(revision 217)
@@ -8,12 +8,4 @@
     <userSettings>
         <HeuristicLab.PluginInfrastructure.GUI.Properties.Settings>
-            <setting name="PluginSources" serializeAs="Xml">
-                <value>
-                    <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-                        xmlns:xsd="http://www.w3.org/2001/XMLSchema">
-                        <string>http://update.heuristiclab.com/hl30/</string>
-                    </ArrayOfString>
-                </value>
-            </setting>
             <setting name="CacheDir" serializeAs="String">
                 <value>plugins\cache</value>
@@ -28,4 +20,12 @@
                 <value>plugins\temp</value>
             </setting>
+            <setting name="PluginSources" serializeAs="Xml">
+                <value>
+                    <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+                        xmlns:xsd="http://www.w3.org/2001/XMLSchema">
+                        <string>http://update.heuristiclab.com/hl30/</string>
+                    </ArrayOfString>
+                </value>
+            </setting>
         </HeuristicLab.PluginInfrastructure.GUI.Properties.Settings>
     </userSettings>