Index: trunk/sources/HeuristicLab.DataAnalysis/DatasetView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataAnalysis/DatasetView.cs	(revision 233)
+++ trunk/sources/HeuristicLab.DataAnalysis/DatasetView.cs	(revision 234)
@@ -23,4 +23,5 @@
 using System.Windows.Forms;
 using HeuristicLab.Core;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.DataAnalysis {
@@ -39,4 +40,11 @@
       : base() {
       InitializeComponent();
+      DiscoveryService discovery = new DiscoveryService();
+      IDatasetManipulator[] manipuators = discovery.GetInstances<IDatasetManipulator>();
+      contextMenuStrip.Items.Add(new ToolStripSeparator());
+      foreach(IDatasetManipulator manipulator in manipuators) {
+        contextMenuStrip.Items.Add(new ToolStripButton(manipulator.Action,null , delegate(object source, EventArgs args) 
+          { manipulator.Execute(Dataset); }));
+      }
     }
 
Index: trunk/sources/HeuristicLab.DataAnalysis/HeuristicLab.DataAnalysis.csproj
===================================================================
--- trunk/sources/HeuristicLab.DataAnalysis/HeuristicLab.DataAnalysis.csproj	(revision 233)
+++ trunk/sources/HeuristicLab.DataAnalysis/HeuristicLab.DataAnalysis.csproj	(revision 234)
@@ -60,7 +60,11 @@
     </Compile>
     <Compile Include="HeuristicLabDataAnalysisPlugin.cs" />
+    <Compile Include="IDatasetManipulator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Regression.cs" />
     <Compile Include="Statistics.cs" />
+    <Compile Include="SvmExporter.cs">
+      <SubType>Form</SubType>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
@@ -87,4 +91,8 @@
       <SubType>Designer</SubType>
     </EmbeddedResource>
+    <EmbeddedResource Include="SvmExporter.resx">
+      <DependentUpon>SvmExporter.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: trunk/sources/HeuristicLab.DataAnalysis/IDatasetManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.DataAnalysis/IDatasetManipulator.cs	(revision 234)
+++ trunk/sources/HeuristicLab.DataAnalysis/IDatasetManipulator.cs	(revision 234)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.DataAnalysis {
+  interface IDatasetManipulator {
+    string Action { get; }
+    void Execute(Dataset dataset);
+  }
+}
Index: trunk/sources/HeuristicLab.DataAnalysis/SvmExporter.cs
===================================================================
--- trunk/sources/HeuristicLab.DataAnalysis/SvmExporter.cs	(revision 234)
+++ trunk/sources/HeuristicLab.DataAnalysis/SvmExporter.cs	(revision 234)
@@ -0,0 +1,126 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using System.IO;
+using System.Globalization;
+
+namespace HeuristicLab.DataAnalysis {
+  class SvmExporter : Form, IDatasetManipulator {
+    private Label helpLabel;
+    private Button nextButton;
+    private DataGridView dataGridView;
+    private Dataset dataset;
+    public SvmExporter() : base() {
+      InitializeComponent();
+    }
+
+    #region IDatasetManipulator Members
+    public string Action {
+      get { return "Export to libsvm..."; }
+    }
+
+    public void Execute(Dataset dataset) {
+      this.dataset = dataset;
+      dataGridView.ColumnCount = dataset.Columns;
+      dataGridView.RowCount = dataset.Rows;
+      for(int i = 0; i < dataset.Rows; i++) {
+        for(int j = 0; j < dataset.Columns; j++) {
+          dataGridView.Rows[i].Cells[j].Value = dataset.GetValue(i, j);
+        }
+      }
+      for(int i = 0; i < dataset.Columns; i++) {
+        dataGridView.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
+        dataGridView.Columns[i].Name = dataset.VariableNames[i];
+      }
+      dataGridView.SelectionMode = DataGridViewSelectionMode.ColumnHeaderSelect;
+
+      ShowDialog();
+    }
+
+    #endregion
+
+    private void InitializeComponent() {
+      this.dataGridView = new System.Windows.Forms.DataGridView();
+      this.helpLabel = new System.Windows.Forms.Label();
+      this.nextButton = new System.Windows.Forms.Button();
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // dataGridView
+      // 
+      this.dataGridView.AllowUserToAddRows = false;
+      this.dataGridView.AllowUserToDeleteRows = false;
+      this.dataGridView.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dataGridView.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+      this.dataGridView.Location = new System.Drawing.Point(12, 25);
+      this.dataGridView.Name = "dataGridView";
+      this.dataGridView.ReadOnly = true;
+      this.dataGridView.Size = new System.Drawing.Size(568, 200);
+      this.dataGridView.TabIndex = 0;
+      this.dataGridView.SelectionChanged += new System.EventHandler(this.dataGridView_SelectionChanged);
+      // 
+      // helpLabel
+      // 
+      this.helpLabel.AutoSize = true;
+      this.helpLabel.Location = new System.Drawing.Point(12, 9);
+      this.helpLabel.Name = "helpLabel";
+      this.helpLabel.Size = new System.Drawing.Size(231, 13);
+      this.helpLabel.TabIndex = 1;
+      this.helpLabel.Text = "Please select the column of  the target variable.";
+      // 
+      // nextButton
+      // 
+      this.nextButton.Location = new System.Drawing.Point(505, 231);
+      this.nextButton.Name = "nextButton";
+      this.nextButton.Size = new System.Drawing.Size(75, 23);
+      this.nextButton.TabIndex = 2;
+      this.nextButton.Text = "Next...";
+      this.nextButton.UseVisualStyleBackColor = true;
+      this.nextButton.Click += new System.EventHandler(this.nextButton_Click);
+      // 
+      // SvmExporter
+      // 
+      this.ClientSize = new System.Drawing.Size(592, 266);
+      this.Controls.Add(this.nextButton);
+      this.Controls.Add(this.helpLabel);
+      this.Controls.Add(this.dataGridView);
+      this.Name = "SvmExporter";
+      this.Text = "Execute to libSVM";
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    private void dataGridView_SelectionChanged(object sender, EventArgs e) {
+      if(dataGridView.SelectedColumns.Count == 1) nextButton.Enabled = true;
+      else nextButton.Enabled = false;
+    }
+
+    private void nextButton_Click(object sender, EventArgs e) {
+      int targetColumn = dataGridView.SelectedColumns[0].Index;
+
+      SaveFileDialog saveDialog = new SaveFileDialog();
+      if(saveDialog.ShowDialog() == DialogResult.OK) {
+        string filename = saveDialog.FileName;
+        StreamWriter writer = new StreamWriter(filename);
+        for(int i = 0; i < dataset.Rows; i++) {
+          writer.Write(dataset.GetValue(i, targetColumn).ToString(CultureInfo.InvariantCulture) + "\t");
+          for(int j = 0; j < dataset.Columns; j++) {
+            if(j != targetColumn) {
+              double val = dataset.GetValue(i, j);
+              if(!double.IsInfinity(val) && !double.IsNaN(val))
+                writer.Write((j + 1) + ":" + val.ToString(CultureInfo.InvariantCulture) + "\t");
+            }
+          }
+          writer.WriteLine();
+        }
+        writer.Close();
+      }
+      Close();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.DataAnalysis/SvmExporter.resx
===================================================================
--- trunk/sources/HeuristicLab.DataAnalysis/SvmExporter.resx	(revision 234)
+++ trunk/sources/HeuristicLab.DataAnalysis/SvmExporter.resx	(revision 234)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>